(ns com.aurellem.exp.assembly
   (:use (com.aurellem.gb gb-driver vbm title items))
   (:import [com.aurellem.gb.gb_driver SaveState]))


(defn run-item-program
  "This is my first assembly/item program!
   it just increments BC by one.

   The code places a 3 'great balls' at the beginning of the
   inventory, then directly sets the program counter to start
   executing at the position of the 'great balls' in memory.

   Since a 'great ball' is represented in memory as 0x03, which
   corresponts to the opcode which increments BC by one, that is
   what happens. Then the program counter to the 0x03 quantity entry
   and BC is incremented again.

   Obviously, the game crashes more or less immediately after the
   program counter advances past the 'great balls' into the next items
   in the inventory, thus I call shutdown! before anything bad happens."
  []
  (set-inventory (read-state "mid-game") [[:great-ball 3]])
  (print-inventory)
  (println "3 ticks") (tick) (tick) (tick)
  (println "PC before:" (PC))
  (println "BC before:" (BC))
  (PC! (inc item-list-start))
  (println "PC after setting:" (PC))
  (println "data at PC:" (aget (memory) (PC)))
  (println "one tick")
  (tick)
  (println "PC after one tick:" (PC))
  (println "BC after one tick:" (BC))
  (tick)
  (println "PC after two ticks:" (PC))
  (println "BC after two ticks:" (BC))

  (shutdown!))




(defn test-opcodes-1
  []
  (let [final-state
        (->
         (read-state "mid-game")
         (set-inv-mem 
          [20 0x02 0x00 0x00 0x02 0x00 0x00
           0x00 0x0 0xFF])
         (print-inventory)
         ;;((fn [_] (println "3 ticks") _))
         (tick) (tick) (tick)
         
         ;;(println "PC before:" (PC))
         ;;(println "BC before:" (BC))
         ;;(println "AF:" (AF))
         (PC! (inc item-list-start))
         (BC! (+ 1 item-list-start))
         ;;(println "PC after setting:" (PC))
         ;;(println "data at PC:" (aget (memory) (PC)))
         ;;(println "data at " (BC) "(BC):" (aget (memory) (BC)))
         
         ;;(println "one tick")
         (tick)
         ;;(println "PC after one tick:" (PC))
         ;;(println "BC after one tick:" (BC))
         ;;(println "data at PC:" (aget (memory) (PC)))
         ;;(println "data at " (BC) "(BC):" (aget (memory) (BC)))
         (tick)
         (AF! 0xFFFF)
         ;;(println "PC after two ticks:" (PC))
         ;;(println "BC after two ticks:" (BC))
         ;;(println "data at PC:" (aget (memory) (PC)))
         ;;(println "data at " (BC) "(BC):" (aget (memory) (BC)))
         (tick)
         ;;(println "PC after three ticks:" (PC))
         ;;(println "BC after three ticks:" (BC))
         ;;(println "data at PC:" (aget (memory) (PC)))
         ;;(println "data at " (BC) "(BC):" (aget (memory) (BC)))
         (tick)
         ;;(println "PC after four ticks:" (PC))
         ;;(println "BC after four ticks:" (BC))
         ;;(println "data at PC:" (aget (memory) (PC)))
         ;;(println "data at " (BC) "(BC):" (aget (memory) (BC)))
         (tick)
         ;;(println "PC after five ticks:" (PC))
         ;;(println "BC after five ticks:" (BC))
         ;;(println "data at PC:" (aget (memory) (PC)))
         ;;(println "data at " (BC) "(BC):" (aget (memory) (BC)))
         (print-inventory)
         )]
    
    (shutdown!)
    final-state))



(defn test-opcodes-2
  []
  (set-inv-mem (read-state "mid-game")
               [20 0x08 0x1D 0xD3 0x00 0x00 0x00
                0x00 0x0 0xFF])
  (print-inventory)
  (println "3 ticks") (tick) (tick) (tick)
  (println "PC before:" (PC))
  (println "SP:" (SP))
  (PC! (inc item-list-start))
  (println "PC after setting:" (PC))
  (println "SP:" (Integer/toBinaryString (SP)))
  (println "data at PC:" (aget (memory) (PC)))
  (println "data at 0xD31D:" (Integer/toBinaryString (aget (memory) 0xD31D)))
  (println "data at 0xD31E:" (Integer/toBinaryString (aget (memory) 0xD31E)))
  (println "one tick")
  (tick)
  (println "PC after one tick:" (PC))
  (println "data at PC:" (aget (memory) (PC)))
  (println "data at 0xD31D:" (Integer/toBinaryString (aget (memory) 0xD31D)))
  (println "data at 0xD31E:" (Integer/toBinaryString (aget (memory) 0xD31E)))
  (tick) (tick) (tick)
  (println "PC aftter four tick:" (PC))
  (println "data at PC:" (aget (memory) (PC)))
  (println "data at 0xD31D:" (aget (memory) 0xD31D))
  
  (print-inventory)
  (shutdown!))

